LIBRARY ieee;
USE ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;

ENTITY LATCH_IRS_DATA0204 IS
	PORT
	(
		IRS_IN				: IN	STD_LOGIC;
		CLK					: IN	STD_LOGIC;
		START				: IN	STD_LOGIC;
		FLAG				: out	STD_LOGIC;
		POST_DATA			: out	STD_LOGIC_VECTOR(11 DOWNTO 0)
	);
END LATCH_IRS_DATA0204;

ARCHITECTURE RTL OF LATCH_IRS_DATA0204 IS
	SIGNAL IRS	: STD_LOGIC_VECTOR(11 DOWNTO 0);
	SIGNAL Q	: integer range 0 to 742720;

BEGIN	
	
	PROCESS(CLK)
	BEGIN
		if(CLK'EVENT AND CLK = '1') then
			IF(START = '1')THEN
				Q <= 0;

			ELSE
	 			IF(Q = 6752)THEN
		 			IRS(11 DOWNTO 1) <= IRS(10 DOWNTO 0);
					IRS(0) <= IRS_IN;
					Q <= Q + 1;

					IF(IRS(11 DOWNTO 6) = "111100")THEN
						CASE irs(6 downto 1) is
							when "100000" => POST_DATA(11 DOWNTO 0) <= "000000000001";
							when "010000" => POST_DATA(11 DOWNTO 0) <= "000000000010";
							when "001000" => POST_DATA(11 DOWNTO 0) <= "000000000100";
							when "000100" => POST_DATA(11 DOWNTO 0) <= "000000001000";
							when "000010" => POST_DATA(11 DOWNTO 0) <= "000000010000";
							when others   => POST_DATA(11 DOWNTO 0) <= "000000000000";
						end CASE;
					FLAG <= '1';	
					END IF;

				ELSIF(Q = 742720)THEN
					POST_DATA <= "000000000000";
					Q <= 0;
					FLAG <= '0';

				ELSE
					Q <= Q + 1;
					
				End if;
			END IF;
		END IF;
	end process;
end RTL;

