LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY selecter IS
	PORT
	(
		IORN		: IN	STD_LOGIC;
		MPC_ADD		: IN	STD_LOGIC;
		MPC_DATA	: IN	STD_LOGIC_VECTOR(7 downto 0);
		RE_ADD		: IN	STD_LOGIC;
		RE_DATA		: IN	STD_LOGIC_VECTOR(15 downto 0);
		TLD_ADD		: IN	STD_LOGIC;
		TLD_DATA	: IN	STD_LOGIC_VECTOR(15 downto 0);
		IRS_ADD		: IN	STD_LOGIC;
		IRS_DATA	: IN	STD_LOGIC_VECTOR(15 downto 0);
		DATA_OUT	: OUT 	STD_LOGIC_VECTOR(15 downto 0)
	);
END selecter;

ARCHITECTURE RTL OF selecter IS
	signal OUT_P	: std_logic_vector(15 downto 0);
BEGIN
	PROCESS (IORN
			,MPC_ADD,MPC_DATA
			,RE_ADD,RE_DATA
			,TLD_ADD,TLD_DATA
			,IRS_ADD,IRS_DATA)
	BEGIN
		if (IORN = '0') then
			if( MPC_ADD = '1')then
				OUT_P(7 downto 0) <= MPC_DATA;
				OUT_P(15 downto 8) <= "00000000";
				elsif(RE_ADD = '1')then
					OUT_P <= RE_DATA;
				elsif(TLD_ADD = '1')then
					OUT_P <= TLD_DATA;
				elsif(IRS_ADD = '1')then
					OUT_P <= IRS_DATA;
				else
					OUT_P <= "0000000000000000";
			end if;
			else
				OUT_P <= OUT_P; 

 		END IF;
	END PROCESS;	
	DATA_OUT <= OUT_P;
END RTL;

